You can not select more than 25 topics
Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
|
|
#!/bin/bash
## Init is run on host ## For now it is run every time the script is launched, but ## it should be launched only once after build.
## Accessible variables are: ## - SERVICE_NAME Name of current service ## - DOCKER_BASE_IMAGE Base image from which this service might be built if any ## - SERVICE_DATASTORE Location on host of the DATASTORE of this service ## - SERVICE_CONFIGSTORE Location on host of the CONFIGSTORE of this service
set -e
service_def=$(get_compose_service_def "$SERVICE_NAME")
keys=$(echo "$service_def" | shyaml -y get-value options.keys 2>/dev/null) || { err "You must specify a ${WHITE}keys${NORMAL} struct to use this service" exit 1 }
[ "$(echo "$keys" | shyaml -y get-type 2>/dev/null)" == "struct" ] || { err "Invalid value type for ${WHITE}keys${NORMAL}, please provide a struct" exit 1 }
local_path_key=/etc/rsync/keys host_path_key="$SERVICE_CONFIGSTORE${local_path_key}" key_nb=0
volume_keys=() all_keys=" " while read-0 ident key; do if ! [[ "$ident" =~ ^[a-zA-Z0-9._-]+$ ]]; then err "Invalid identifier '$ident'," \ "please use only alphanumerical char, dots, dash or underscores." exit 1 fi debug "Creating access key for ${ident}" || true echo "$key" | file_put "$host_path_key/${ident}.pub" done < <(echo "$keys" | shyaml key-values-0)
volume_keys+=("$host_path_key:$local_path_key:ro")
init-config-add "\ $SERVICE_NAME: volumes: - $host_path_key:$local_path_key:ro "
|